#EndRegion # Network Status

Opt("MustDeclareVars", 1) ;0=no, 1=require pre-declaration
Opt("TrayMenuMode", 3) ;0=append, 1=no default menu, 2=no automatic check, 4=menuitemID  not return
Opt("TrayOnEventMode", 1) ;0=disable, 1=enable

Global $oErrorHandler = ObjEvent("AutoIt.Error", "_SkipObjectError")
Func _SkipObjectError()
	; Do nothing special, just check @error after suspect functions.
EndFunc   ;==>_SkipObjectError

#Region #include
;~ #include <ButtonConstants.au3>
;~ #include <GUIConstantsEx.au3>
;~ #include <StaticConstants.au3>
;~ #include <WindowsConstants.au3>
;~ #include <Inet.au3>
Global Const $BS_CENTER = 0x0300
Global Const $BS_VCENTER = 0x0C00
Global Const $BS_FLAT = 0x8000
Global Const $SS_CENTER = 0x1
Global Const $SS_RIGHT = 0x2
Global Const $SS_CENTERIMAGE = 0x0200
Global Const $WS_BORDER = 0x00800000
Global Const $STR_REGEXPARRAYGLOBALMATCH = 3
Global Const $BS_DEFPUSHBUTTON = 0x0001
Global Const $GUI_EVENT_CLOSE = -3
Global Const $GUI_EVENT_MINIMIZE = -4
Global Const $GUI_EVENT_RESTORE = -5
Global Const $MB_ICONWARNING = 48
Global Const $MB_ICONINFORMATION = 64
Global Const $MB_TOPMOST = 0x00040000
#EndRegion #include

#Region GUI
Global Const $sGUI_Title = "Network Adapter Info"
Global $hMainGUI = GUICreate($sGUI_Title, 575, 191, -1, -1)
GUICtrlCreateLabel("Adapter:", 5, 10, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("Name:", 5, 40, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("Status:", 5, 65, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("IP:", 5, 90, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("WanIP:", 220, 90, 50, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("MAC:", 5, 115, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("SubnetIP:", 220, 115, 50, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("Getway IP:", 5, 140, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("DNS1:", 220, 140, 50, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("Getway MAC:", 5, 165, 70, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
GUICtrlCreateLabel("DNS2:", 220, 165, 50, 20, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
Global $cAdapter = GUICtrlCreateButton("", 80, 5, 400, 30, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cAdapterName = GUICtrlCreateButton("", 80, 40, 249, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cSpeed = GUICtrlCreateButton("", 335, 40, 65, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $cPageID = GUICtrlCreateButton("", 408, 40, 73, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $cGetIPType = GUICtrlCreateButton("", 80, 65, 120, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $cAdapterStatus = GUICtrlCreateLabel("", 272, 65, 129, 20, BitOR($SS_CENTER, $SS_CENTERIMAGE, $WS_BORDER))
Global $cIP = GUICtrlCreateButton("", 80, 90, 120, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cIndex = GUICtrlCreateButton("", 202, 65, 68, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Interface Index")
Global $cWanIP = GUICtrlCreateButton("", 272, 90, 130, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cMAC = GUICtrlCreateButton("", 80, 115, 120, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cSubNetIP = GUICtrlCreateButton("", 272, 115, 130, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cGetwayIP = GUICtrlCreateButton("", 80, 140, 120, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cDNS1 = GUICtrlCreateButton("", 272, 140, 130, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cGetwayMAC = GUICtrlCreateButton("", 80, 165, 120, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $cDNS2 = GUICtrlCreateButton("", 272, 165, 130, 20, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY!")
Global $bNEXT = GUICtrlCreateButton("NEXT", 485, 5, 80, 55, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Next Interface")
Global $bOpenNetCon = GUICtrlCreateButton("Open Network Connections", 410, 65, 155, 21, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $bSaveINI = GUICtrlCreateButton("Export INI", 410, 90, 110, 21, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $bCopyINI = GUICtrlCreateButton("COPY", 525, 90, 41, 21, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY ALL Info as INI Format!")
Global $bSaveCSV = GUICtrlCreateButton("Export CSV", 410, 115, 110, 21, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
Global $bCopyCSV = GUICtrlCreateButton("COPY", 525, 115, 41, 21, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
GUICtrlSetTip(-1, "Click for COPY ALL Info as CSV Format!")
Global $bREFRESH = GUICtrlCreateButton("Refresh", 410, 140, 155, 46, BitOR($BS_CENTER, $BS_VCENTER, $BS_FLAT))
#EndRegion GUI
Global $sAdapter, $sAdapterName, $sSpeed, $sIndex, $sGetIPType, $sAdapterStatus, $sIP, $sWanIP, $sMAC, $sSubNetIP, $sGetwayIP, $sDNS1, $sGetwayMAC, $sDNS2
Global Const $sNotAvailable = "N/A"
Global Const $sBlankIP = "0.0.0.0"
Global Const $sBlankMAC = "00:00:00:00:00:00"
Global $sAdapterInfo, $sPage = 0, $netStatus = 0
FileInstall("Icon_1.ico", @TempDir & "\Icon_1.ico", 1)
FileInstall("Icon_2.ico", @TempDir & "\Icon_2.ico", 1)
FileInstall("Icon_3.ico", @TempDir & "\Icon_3.ico", 1)
FileInstall("Icon_4.ico", @TempDir & "\Icon_4.ico", 1)
SplashTextOn($sGUI_Title, "Collecting information, please waiting...", 360, 50)
_RefehData()
#Region # CMDLine
If $CmdLine[0] > 0 Then
	Local $sFileLog = $CmdLine[1]
	Local $hOpenLog = FileOpen($sFileLog, 2 + 8 + 256)
	If $CmdLine[0] > 1 Then
		If StringInStr(StringLower($CmdLine[2]), "csv") Then
			FileWrite($hOpenLog, CreateContentCSV())
		Else
			FileWrite($hOpenLog, CreateContentINI())
		EndIf
	Else
		FileWrite($hOpenLog, CreateContentINI())
	EndIf
	FileClose($hOpenLog)
	Exit
EndIf
#EndRegion # CMDLine

Global $sTray = TrayCreateItem("Hide")
TrayItemSetOnEvent($sTray, "_TrayClick")
TrayCreateItem("") ; Create a separator line.
Global $idExit = TrayCreateItem("Exit")
TrayItemSetOnEvent($idExit, "_OnExit")
TraySetClick(8)
TraySetState()

SplashOff()
GUISetState(@SW_SHOW)
While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_MINIMIZE
			TrayItemSetText($sTray, "Show")
		Case $GUI_EVENT_RESTORE
			TrayItemSetText($sTray, "Hide")
		Case $GUI_EVENT_CLOSE
			_OnExit()
		Case $cAdapter
			ClipPut(GUICtrlRead($cAdapter, 1))
		Case $cAdapterName
			ClipPut(GUICtrlRead($cAdapterName, 1))
		Case $cIP
			ClipPut(GUICtrlRead($cIP, 1))
		Case $cWanIP
			ClipPut(GUICtrlRead($cWanIP, 1))
		Case $cMAC
			ClipPut(GUICtrlRead($cMAC, 1))
		Case $cSubNetIP
			ClipPut(GUICtrlRead($cSubNetIP, 1))
		Case $cGetwayIP
			ClipPut(GUICtrlRead($cGetwayIP, 1))
		Case $cDNS1
			ClipPut(GUICtrlRead($cDNS1, 1))
		Case $cDNS2
			ClipPut(GUICtrlRead($cDNS2, 1))
		Case $cGetwayMAC
			ClipPut(GUICtrlRead($cGetwayMAC, 1))
		Case $bOpenNetCon
;~ 			ShellExecute("C:\windows\system32\ncpa.cpl")
			ShellExecute("::{7007ACC7-3202-11D1-AAD2-00805FC1270E}")
		Case $bSaveINI
			Local $sFileToSave = FileSaveDialog("Export to INI file", @DesktopDir, "Configuration Settings (.ini)", 16, $sGUI_Title, $hMainGUI)
			If Not @error Then
				Local $hOpen = FileOpen($sFileToSave, 2 + 8 + 256)
				FileWrite($hOpen, CreateContentINI())
				If @error Then
					MsgBox(48 + 262144, "Export INI", "An error occurred during the save file: " & $sFileToSave, Default, $hMainGUI)
				Else
					FileClose($hOpen)
					MsgBox(32 + 262144, "Export INI", "Save successful.", Default, $hMainGUI)
				EndIf
			EndIf
		Case $bCopyINI
			ClipPut(CreateContentINI())
		Case $bSaveCSV
			Local $sFileToSave = FileSaveDialog("Export to CSV file", @DesktopDir, "Comma Separated Values (.csv)", 16, $sGUI_Title, $hMainGUI)
			If Not @error Then
				Local $hOpen = FileOpen($sFileToSave, 2 + 8 + 256)
				FileWrite($hOpen, CreateContentCSV())
				If @error Then
					MsgBox(48 + 262144, "Export CSV", "An error occurred during the save file: " & $sFileToSave, Default, $hMainGUI)
				Else
					FileClose($hOpen)
					MsgBox(32 + 262144, "Export CSV", "Save successful.", Default, $hMainGUI)
				EndIf
			EndIf
		Case $bCopyCSV
			ClipPut(CreateContentCSV())
		Case $bNEXT
			_NextNIC()
		Case $bREFRESH
			_RefehData()
	EndSwitch
;~ 	Local $objWMIService = ObjGet("winmgmts:\\.\root\cimv2")
;~ 	Local $colEvents = $objWMIService.ExecNotificationQuery("Select * From __InstanceOperationEvent Within 1 Where TargetInstance isa '" & "Win32_NetworkAdapter'")
;~ 	Local $objEvent = $colEvents.NextEvent
;~ 	If $objEvent.Path_.Class() = "__InstanceModificationEvent" Then
;~ 		If $objEvent.TargetInstance.NetConnectionStatus <> $objEvent.PreviousInstance.NetConnectionStatus Then
;~ 			Select
;~ 				Case $objEvent.TargetInstance.NetConnectionStatus = 2
;~ 					TrayTip("Interface was enabled: ", $objEvent.TargetInstance.Name, 4, 1)
;~ 				Case $objEvent.TargetInstance.NetConnectionStatus = 0
;~ 					TrayTip("Interface was disabled: ", $objEvent.TargetInstance.Name, 4, 1)
;~ 			EndSelect
;~ 		EndIf
;~ 	EndIf
	_CheckConnect()
	Sleep(10)
WEnd
#Region # Function
;==>_RefehData
Func _RefehData()
	$sAdapterInfo = _GetListAdaptersInfo(".") ;@ComputerName
	_SetDataToGUI(1)
	$sWanIP = _GetIP()
	GUICtrlSetData($cWanIP, $sWanIP)
	If $sAdapterInfo[0][0] <= 1 Then
		GUICtrlSetState($bNEXT, 128) ;$GUI_DISABLE
	Else
		GUICtrlSetState($bNEXT, 64) ;$GUI_ENABLE
	EndIf
EndFunc   ;==>_RefehData
;==>_GetDataSetVar
Func _GetDataSetVar($x = 1)
	If Not IsArray($sAdapterInfo) Then _RefehData()
	If IsArray($sAdapterInfo) And $sAdapterInfo[0][0] > 0 Then
		$sIndex = $sAdapterInfo[$x][0]
		$sAdapter = $sAdapterInfo[$x][1]
		$sAdapterName = $sAdapterInfo[$x][2]
		$sAdapterStatus = $sAdapterInfo[$x][3]
		$sGetIPType = $sAdapterInfo[$x][4]
		$sIP = $sAdapterInfo[$x][5]
		$sSubNetIP = $sAdapterInfo[$x][6]
		$sMAC = $sAdapterInfo[$x][7]
		$sGetwayIP = $sAdapterInfo[$x][8]
		$sGetwayMAC = $sAdapterInfo[$x][9]
		$sDNS1 = $sAdapterInfo[$x][10]
		$sDNS2 = $sAdapterInfo[$x][11]
		$sSpeed = $sAdapterInfo[$x][12]
		Return 1
	Else
		Return SetError(1, 0, False)
	EndIf
EndFunc   ;==>_GetDataSetVar
;==>_SetDataToGUI
Func _SetDataToGUI($x = 1)
	_GetDataSetVar($x)
	If $sPage <= 0 Then $sPage = 1
	GUICtrlSetData($cPageID, "NIC: " & $sPage & "/" & $sAdapterInfo[0][0])
	GUICtrlSetData($cIndex, "ID: " & $sIndex)
	GUICtrlSetData($cAdapter, $sAdapter)
	GUICtrlSetData($cAdapterName, $sAdapterName)
	GUICtrlSetData($cSpeed, $sSpeed)
	GUICtrlSetData($cGetIPType, $sGetIPType)
	GUICtrlSetData($cIP, $sIP)
	GUICtrlSetData($cSubNetIP, $sSubNetIP)
	GUICtrlSetData($cMAC, $sMAC)
	GUICtrlSetData($cGetwayIP, $sGetwayIP)
	GUICtrlSetData($cGetwayMAC, $sGetwayMAC)
	GUICtrlSetData($cDNS1, $sDNS1)
	GUICtrlSetData($cDNS2, $sDNS2)
	GUICtrlSetData($cAdapterStatus, $sAdapterStatus)
;~ 	GUICtrlSetData($cWanIP, $sWanIP)
EndFunc   ;==>_SetDataToGUI
;==>_NextNIC
Func _NextNIC()
	If Not IsArray($sAdapterInfo) Then _RefehData()
	If $sPage <= 0 Then $sPage = 1
	If IsArray($sAdapterInfo) And $sAdapterInfo[0][0] > 0 Then
		$sPage += 1
		If $sPage > $sAdapterInfo[0][0] Then $sPage = 1
		_SetDataToGUI($sPage)
	Else
		GUICtrlSetData($cPageID, "0") ;ID
		ShellExecute("::{7007ACC7-3202-11D1-AAD2-00805FC1270E}")
;~ 		MsgBox($MB_ICONWARNING + $MB_TOPMOST, "Error!", "Get Network Status: Failure !" & @CRLF & 'Please "Enable" some Network Adapters.', 10, $hMainGUI)
	EndIf
EndFunc   ;==>_NextNIC
;==>_GetListAdaptersInfo
Func _GetListAdaptersInfo($sComputer = ".")
	Local $Cols = 13, $strIndex, $objVAR, $objVARx, $zAdapter, $zAdapterName, $zSpeed, $zIndex, $zInterfaceIndex, $zGetIPType, $zAdapterStatus, $zIP, $zMAC, $zSubNetIP, $zGetwayIP, $zDNS1, $zGetwayMAC, $zDNS2
	Local $aReturn[1][$Cols] = [[0, $Cols]]
	If $sComputer = Default Then $sComputer = @ComputerName
	Local $sListIndexInterfaceName = _ListIndexInterfaceName()
	Local $objWMI = ObjGet("winmgmts:\\" & $sComputer & "\root\cimv2")
	Local $objWQLx = $objWMI.ExecQuery("SELECT * FROM Win32_NetworkAdapter WHERE NetConnectionID != NULL", "WQL", 0x30)
;~ 	Local $objWQLx = $objWMI.ExecQuery('Select * From Win32_NetworkAdapter', "WQL", 0x30)
	If Not @error And IsObj($objWQLx) Then
		For $objVARx In $objWQLx
			$zAdapterName = $objVARx.NetConnectionID
			If (StringStripWS($zAdapterName, 8) = "") Then ContinueLoop
			$zSpeed = _ByteSuffixRound($objVARx.Speed) ; Vista+
			If Int($zSpeed) <= 0 Then
				For $z = 0 To UBound($sListIndexInterfaceName) - 1
					If $sListIndexInterfaceName[$z][1] = $zAdapterName Then $zSpeed = _ByteSuffixRound(InterfaceIndexSpeed($sListIndexInterfaceName[$z][0]))
				Next
			EndIf
			$zAdapterStatus = $objVARx.NetConnectionStatus
			Switch $zAdapterStatus
				Case 0, 3
					$zAdapterStatus = "Disable"
				Case 1, 2
					$zAdapterStatus = "Connected"
				Case $zAdapterStatus = 7
					$zAdapterStatus = "unPlugged"
				Case Else
					$zAdapterStatus = $sNotAvailable
			EndSwitch
			$strIndex = $objVARx.Index
			Local $objWQL = $objWMI.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration WHERE Index=' & $strIndex, "WQL", 0x30)
			If Not @error And IsObj($objWQL) Then
				For $objVAR In $objWQL
					$zAdapter = $objVAR.Description
					$aReturn[0][0] += 1
					$zIndex = $aReturn[0][0]
					ReDim $aReturn[$zIndex * 2][$aReturn[0][1]]
					$zInterfaceIndex = $objVAR.InterfaceIndex
					If Int($zInterfaceIndex) <= 0 Then
						For $z = 0 To UBound($sListIndexInterfaceName) - 1
							If $sListIndexInterfaceName[$z][1] = $zAdapterName Then $zInterfaceIndex = $sListIndexInterfaceName[$z][0]
						Next
					EndIf
					$aReturn[$zIndex][0] = $zInterfaceIndex
					$aReturn[$zIndex][1] = $zAdapter
					$aReturn[$zIndex][2] = $zAdapterName
					$aReturn[$zIndex][3] = $zAdapterStatus
					$zGetIPType = $objVAR.DHCPEnabled
					If $zGetIPType Then
						$zGetIPType = "DHCP"
					Else
						$zGetIPType = "StaticIP"
					EndIf
					$aReturn[$zIndex][4] = $zGetIPType
					$zIP = $objVAR.IPAddress(0)
					If StringStripWS($zIP, 8) = "" Then $zIP = $sNotAvailable
					$aReturn[$zIndex][5] = $zIP
					$zSubNetIP = $objVAR.IPSubnet(0)
					If StringStripWS($zSubNetIP, 8) = "" Then $zSubNetIP = $sNotAvailable
					$aReturn[$zIndex][6] = $zSubNetIP
					$zMAC = $objVAR.MACAddress
					If StringStripWS($zMAC, 8) = "" Then $zMAC = $sNotAvailable
					$aReturn[$zIndex][7] = $zMAC
					$zGetwayIP = $objVAR.DefaultIPGateway(0)
					If StringStripWS($zGetwayIP, 8) = "" Then $zGetwayIP = $sNotAvailable
					$aReturn[$zIndex][8] = $zGetwayIP
					$zGetwayMAC = $sNotAvailable
					If $zGetwayIP <> $sNotAvailable Then $zGetwayMAC = _GetMACFromIP($zGetwayIP)
					$aReturn[$zIndex][9] = $zGetwayMAC
					$aReturn[$zIndex][10] = $sNotAvailable
					$aReturn[$zIndex][11] = $sNotAvailable
					If Number($zSpeed) = 0 Then $zSpeed = $sNotAvailable
					$aReturn[$zIndex][12] = $zSpeed
					Local $zDNS = $objVAR.DNSServerSearchOrder()
					If IsArray($zDNS) Then
						If (UBound($zDNS) - 1) > 0 Then
							$aReturn[$zIndex][10] = $zDNS[0]
							$aReturn[$zIndex][11] = $zDNS[1]
						Else
							$aReturn[$zIndex][10] = $zDNS[0]
						EndIf
					EndIf
				Next
			EndIf
		Next
		Return $aReturn
	EndIf
	Return SetError(1, 0, "")
EndFunc   ;==>_GetListAdaptersInfo
Func _ListIndexInterfaceName()
	Local Const $tagIP_ADAPTER_ADDRESSES = "ulong Length;dword IfIndex;ptr Next;ptr AdapterName;ptr FirstUnicastAddress;" & "ptr FirstAnycastAddress;ptr FirstMulticastAddress;ptr FirstDnsServerAddress;ptr DnsSuffix;ptr Description;" & "ptr FriendlyName;byte PhysicalAddress[8];dword PhysicalAddressLength;dword Flags;dword Mtu;dword IfType;int OperStatus;" & "dword Ipv6IfIndex;dword ZoneIndices[16];ptr FirstPrefix;" & "uint64 TransmitLinkSpeed;uint64 ReceiveLinkSpeed;ptr FirstWinsServerAddress;ptr FirstGatewayAddress;" & "ulong Ipv4Metric;ulong Ipv6Metric;uint64 Luid;STRUCT;ptr Dhcpv4ServerSockAddr;int Dhcpv4ServerSockAddrLen;ENDSTRUCT;" & "ulong CompartmentId;STRUCT;ulong NetworkGuidData1;word NetworkGuidData2;word NetworkGuidData3;byte NetworkGuidData4[8];ENDSTRUCT;" & "int ConnectionType;int TunnelType;STRUCT;ptr Dhcpv6ServerSockAddr;int Dhcpv6ServerSockAddrLen;ENDSTRUCT;byte Dhcpv6ClientDuid[130];" & "ulong Dhcpv6ClientDuidLength;ulong Dhcpv6Iaid;ptr FirstDnsSuffix;"
	Local $aRet, $nBufSize, $stBuffer, $stIP_ADAPTER_ADDRESSES, $pIPAAStruct, $nIPAAStSize
	Local $pTemp, $nTemp, $nEntries, $aIndexEntries
	$aRet = DllCall("iphlpapi.dll", "ulong", "GetAdaptersAddresses", "ulong", 0, "ulong", 0x86, "ptr", 0, "ptr", 0, "ulong*", 0)
	If @error Then Return SetError(1, @error, "")
	If $aRet[0] Then
		If $aRet[0] <> 111 Or Not $aRet[5] Then Return SetError(2, $aRet[0], "")
	EndIf
	$nBufSize = $aRet[5]
	$stBuffer = DllStructCreate("int64;byte [" & $nBufSize & "];")
	$aRet = DllCall("iphlpapi.dll", "ulong", "GetAdaptersAddresses", "ulong", 0, "ulong", 0x86, "ptr", 0, "ptr", DllStructGetPtr($stBuffer), "ulong*", $nBufSize)
	If @error Then Return SetError(1, @error, "")
	If $aRet[0] Then Return SetError(2, $aRet[0], "")
	Dim $aIndexEntries[Floor($nBufSize / 72)][2]
	$nEntries = 0
	$pIPAAStruct = DllStructGetPtr($stBuffer)
	While $pIPAAStruct <> 0
		$stIP_ADAPTER_ADDRESSES = DllStructCreate($tagIP_ADAPTER_ADDRESSES, $pIPAAStruct)
		$nIPAAStSize = DllStructGetData($stIP_ADAPTER_ADDRESSES, "Length")
		$nTemp = DllStructGetData($stIP_ADAPTER_ADDRESSES, "OperStatus")
		If ($nTemp = 2 And Not False) Or DllStructGetData($stIP_ADAPTER_ADDRESSES, "IfType") = 24 Then
		Else
			$pTemp = DllStructGetData($stIP_ADAPTER_ADDRESSES, "FirstUnicastAddress")
			If $pTemp <> 0 Then
				$aIndexEntries[$nEntries][0] = DllStructGetData($stIP_ADAPTER_ADDRESSES, "IfIndex")
				$aIndexEntries[$nEntries][1] = _GetStringW_FromPtr(DllStructGetData($stIP_ADAPTER_ADDRESSES, "FriendlyName"))
				$nEntries += 1
			EndIf
		EndIf
		$pIPAAStruct = DllStructGetData($stIP_ADAPTER_ADDRESSES, "Next")
	WEnd
	If $nEntries = 0 Then Return SetError(-1, 0, "")
	ReDim $aIndexEntries[$nEntries][2]
	Return SetExtended($nEntries, $aIndexEntries)
EndFunc   ;==>_ListIndexInterfaceName

Func InterfaceIndexSpeed($IfIndex)
	Local $tBuffer, $pBuffer, $iResult, $iSpeed
	$tBuffer = DllStructCreate("wchar[256];dword[5];byte[8];dword[16];char[256]")
	$pBuffer = DllStructGetPtr($tBuffer)
	DllStructSetData($tBuffer, 2, $IfIndex, 1)
	$iResult = DllCall("iphlpapi.dll", "long", "GetIfEntry", "ptr", $pBuffer)
	If @error Then Return SetError(@error, @extended, 0)
	$iSpeed = DllStructGetData($tBuffer, 2, 4)
;~ 	$sDescr = DllStructGetData($tBuffer, 5)
	$tBuffer = 0
	Return SetError($iResult[0], $iSpeed / 1000 / 1000, $iSpeed)
EndFunc   ;==>InterfaceIndexSpeed
Func _GetStringW_FromPtr($pStr)
	If Not IsPtr($pStr) Or $pStr = 0 Then Return SetError(1, 0, "")
	Local $aRet = DllCall("kernel32.dll", "ptr", "lstrcpynW", "wstr", "", "ptr", $pStr, "int", 32767)
	If @error Or Not $aRet[0] Then Return SetError(@error, 0, "")
	Return $aRet[1]
EndFunc   ;==>_GetStringW_FromPtr

Func _GetMACFromIP($rMAC)
	If ($rMAC = "") Or ($rMAC = $sNotAvailable) Then Return $sNotAvailable
	Local $sbMAC = DllStructCreate("byte[6]")
	Local $siMAC = DllStructCreate("int")
	DllStructSetData($siMAC, 1, 6)
	Local $rHexMAC = DllCall("Ws2_32.dll", "int", "inet_addr", "str", $rMAC)
	$rMAC = $rHexMAC[0]
	$rHexMAC = DllCall("iphlpapi.dll", "int", "SendARP", "int", $rMAC, "int", 0, "ptr", DllStructGetPtr($sbMAC), "ptr", DllStructGetPtr($siMAC))
	$rMAC = ""
	For $i = 0 To 5
		If $i Then $rMAC &= ":"
		$rMAC = $rMAC & Hex(DllStructGetData($sbMAC, 1, $i + 1), 2)
	Next
	If ($rMAC = "") Or ($rMAC = $sBlankMAC) Or ($rMAC = $sNotAvailable) Then Return $sNotAvailable
	Return $rMAC
EndFunc   ;==>_GetMACFromIP
;==>_ByteSuffixRound
Func _ByteSuffixRound($iBytes, $iRound = 2)
	$iBytes = Number($iBytes)
	If $iBytes > 1000000000 Then Return $sNotAvailable
	Local $A, $aArray[5] = ["Bps", "Kbps", "Mbps", "Gbps", "Tbps"]
	While $iBytes > 999
		$A += 1
		If $A > 3 Then ExitLoop
		$iBytes /= 1000
	WEnd
	Return Round($iBytes, $iRound) & " " & $aArray[$A]
EndFunc   ;==>_ByteSuffixRound
;==>CreateContentCSV
Func CreateContentCSV()
	Local $sContent
	If Not IsArray($sAdapterInfo) Then _RefehData()
	If IsArray($sAdapterInfo) And $sAdapterInfo[0][0] > 0 Then
		$sContent &= '"NIC","InterfaceIndex","Adapter","AdapterName","AdapterStatus","GetIPType","IP","SubNetIP","MAC","GetwayIP","GetwayMAC","DNS1","DNS2","Speed"' & @CRLF
		For $x = 1 To $sAdapterInfo[0][0]
			$sContent &= '"' & $x & '",'
			$sContent &= '"' & $sAdapterInfo[$x][0] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][1] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][2] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][3] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][4] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][5] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][6] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][7] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][8] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][9] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][10] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][11] & '",'
			$sContent &= '"' & $sAdapterInfo[$x][12] & '"' & @CRLF
		Next
		Return $sContent
	Else
		Return SetError(1, 0, False)
	EndIf
EndFunc   ;==>CreateContentCSV
;==>CreateContentINI
Func CreateContentINI()
	Local $sContent = "[NetworkInfo]" & @CRLF
	$sContent &= "Time = " & @YEAR & "/" & @MON & "/" & @MDAY & "-" & @HOUR & ":" & @MIN & ":" & @SEC & @CRLF
	If Not IsArray($sAdapterInfo) Then _RefehData()
	If IsArray($sAdapterInfo) And $sAdapterInfo[0][0] > 0 Then
		If ($sWanIP = "") Or ($sWanIP = $sNotAvailable) Then $sWanIP = _GetIP
		If ($sWanIP = "") Then $sWanIP = $sNotAvailable
		$sContent &= "WanIP = " & $sWanIP & @CRLF
		$sContent &= "TotalNIC = " & $sAdapterInfo[0][0] & @CRLF & @CRLF
		For $x = 1 To $sAdapterInfo[0][0]
			$sContent &= "[NIC" & $x & "]" & @CRLF
			$sContent &= "InterfaceIndex = " & $sAdapterInfo[$x][0] & @CRLF
			$sContent &= "Adapter = " & $sAdapterInfo[$x][1] & @CRLF
			$sContent &= "AdapterName = " & $sAdapterInfo[$x][2] & @CRLF
			$sContent &= "AdapterStatus = " & $sAdapterInfo[$x][3] & @CRLF
			$sContent &= "GetIPType = " & $sAdapterInfo[$x][4] & @CRLF
			$sContent &= "IP = " & $sAdapterInfo[$x][5] & @CRLF
			$sContent &= "SubNetIP = " & $sAdapterInfo[$x][6] & @CRLF
			$sContent &= "MAC = " & $sAdapterInfo[$x][7] & @CRLF
			$sContent &= "GetwayIP = " & $sAdapterInfo[$x][8] & @CRLF
			$sContent &= "GetwayMAC = " & $sAdapterInfo[$x][9] & @CRLF
			$sContent &= "DNS1 = " & $sAdapterInfo[$x][10] & @CRLF
			$sContent &= "DNS2 = " & $sAdapterInfo[$x][11] & @CRLF
			$sContent &= "Speed = " & $sAdapterInfo[$x][12] & @CRLF & @CRLF
		Next
		Return $sContent
	Else
		Return SetError(1, 0, False)
	EndIf
EndFunc   ;==>CreateContentINI
;==>_CheckConnect
Func _CheckConnect()
	If _Connected() Then
		If $netStatus <> 2 Then
			TrayTip("", "Connection Established", 4, 1)
			TraySetToolTip("Connection Established")
			$netStatus = 2
		EndIf
;~ 		If FileExists(@SystemDir & "\imageres.dll") Then
;~ 			TraySetIcon(@SystemDir & "\imageres.dll", 6200) ; ID:6200_Icon385 ; ID:6203_Icon388
;~ 			Sleep(10)
;~ 			TraySetIcon(@SystemDir & "\imageres.dll", 6203) ; ID:6200_Icon385 ; ID:6203_Icon388
;~ 		Else
;~ 			TraySetIcon(@SystemDir & "\netshell.dll", 193) ;ID:193_Icon69
;~ 		EndIf
		TraySetIcon(@TempDir & "\Icon_1.ico")
		Sleep(10)
		TraySetIcon(@TempDir & "\Icon_2.ico")
	Else
;~ 		If FileExists(@SystemDir & "\imageres.dll") Then
;~ 			TraySetIcon(@SystemDir & "\imageres.dll", 6201) ;  ID:6201_Icon396 ; ID:6204_Icon389
;~ 			TraySetIcon(@SystemDir & "\imageres.dll", 6204) ;  ID:6201_Icon396 ; ID:6204_Icon389
;~ 		Else
;~ 			TraySetIcon(@SystemDir & "\netshell.dll", 195) ; ID:195_Icon71
;~ 		EndIf
		TraySetIcon(@TempDir & "\Icon_3.ico")
		Sleep(10)
		TraySetIcon(@TempDir & "\Icon_4.ico")
		If $netStatus <> 1 Then
			TrayTip("Warning", "Connection Lost", 4, 2)
			TraySetToolTip("Connection Lost")
			$netStatus = 1
		EndIf
	EndIf
EndFunc   ;==>_CheckConnect
;==>_Connected
Func _Connected()
;~ 	Local $Status = DllCall("WinInet.dll", "int", "InternetGetConnectedState", "int_ptr", 0, "int", 0)
;~ 	Return SetError(@error, @extended, $Status[0])
;~ 	Local $aReturn = DllCall('connect.dll', 'long', 'IsInternetConnected')
;~ 	If @error Then Return SetError(1, 0, False)
;~ 	Return $aReturn[0] = 0

	Local $tTYPE, $iData
	$tTYPE = DllStructCreate("int")
	DllCall("sensapi.dll", "int", "IsNetworkAlive", "ptr", DllStructGetPtr($tTYPE))
	$iData = DllStructGetData($tTYPE, 1)
;~     Return $iData>0

	Local $ping = Ping("www.google.com", 500)
	If $ping > 0 Or $iData > 0 Then Return 1
	Return 0
EndFunc   ;==>_Connected
;==>_OnExit
Func _OnExit()
	Exit
EndFunc   ;==>_OnExit
;==>_TrayClick
Func _TrayClick()
	If TrayItemGetText($sTray) = "Hide" Then
		TrayItemSetText($sTray, "Show")
		WinSetState($hMainGUI, "", @SW_MINIMIZE)
	Else
		TrayItemSetText($sTray, "Hide")
		GUISetState(@SW_RESTORE, $hMainGUI)
	EndIf
EndFunc   ;==>_TrayClick
;==>_GetIP()
Func _GetIP()
	Local Const $GETIP_TIMER = 10000
	Local Static $hTimer = 0
	Local Static $sLastIP = 0
	If TimerDiff($hTimer) < $GETIP_TIMER And Not $sLastIP Then
		Return SetExtended(1, $sLastIP)
	EndIf
	Local $aGetIPURL[] = ["http://bot.whatismyipaddress.com", "http://www.myexternalip.com/raw", "http://checkip.dyndns.org"], $aReturn = 0, $sReturn = ""
	HttpSetUserAgent("Mozilla/5.0 (compatible, MSIE 11, Windows NT 6.3; Trident/7.0;  rv:11.0) like Gecko")
	For $i = 0 To UBound($aGetIPURL) - 1
		$sReturn = InetRead($aGetIPURL[$i])
		If @error Or $sReturn = "" Then ContinueLoop
		$aReturn = StringRegExp(BinaryToString($sReturn), "((?:\d{1,3}\.){3}\d{1,3})", $STR_REGEXPARRAYGLOBALMATCH)
		If Not @error Then
			$sReturn = $aReturn[0]
			ExitLoop
		EndIf
		$sReturn = ""
	Next
	$hTimer = TimerInit()
	$sLastIP = $sReturn
	If $sReturn == "" Then Return SetError(1, 0, -1)
	Return $sReturn
EndFunc   ;==>_GetIP

#EndRegion # Function

#Region # Author C490C3A06F2056C4836E2054726F6E67
